﻿/*
 * Copyright (c) 2014, Tess Snider

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
*/

using System;

namespace DesertPaintLab
{
	public partial class ScreenCheckDialog : Gtk.Dialog
	{
		public int ScreenWidth
		{
			get
			{
				return int.Parse(screenWidthEntry.Text);	
			}	
			set
			{
				screenWidthEntry.Text = value.ToString(); 
			}
		}

		public int ScreenHeight
		{
			get
			{
				return int.Parse(screenHeightEntry.Text);	
			}	
			set
			{
				screenHeightEntry.Text = value.ToString();
			}
		}

        private int _detectedScreenWidth;
        private int _detectedScreenHeight;
        public int DetectedScreenWidth
        {
            get
            {
                return _detectedScreenWidth;
            }
            set
            {
                _detectedScreenWidth = value;
                detectedResolutionLabel.Text = string.Format("Detected: {0} x {1}", _detectedScreenWidth, _detectedScreenHeight);
            }
        }

        public int DetectedScreenHeight
        {
            get
            {
                return _detectedScreenHeight;
            }
            set
            {
                _detectedScreenHeight = value;
                detectedResolutionLabel.Text = string.Format("Detected: {0} x {1}", _detectedScreenWidth, _detectedScreenHeight);
            }
        }

        public int GamePixelWidth
		{
			get
			{
				return int.Parse(gamePixelWidthEntry.Text);	
			}	
			set
			{
				gamePixelWidthEntry.Text = value.ToString();
			}
		}

        public InterfaceSize InterfaceSize
        {
            get
            {
                InterfaceSize result = (InterfaceSize)interfaceSizeComboBox.Active;
                return result;
            }
            set
            {
                Gtk.TreeIter iter;
                interfaceSizeComboBox.Model.IterNthChild(out iter, (int)value);
                interfaceSizeComboBox.SetActiveIter(iter);
            }
        }

		public ScreenCheckDialog ()
		{
			this.Build ();
		}
	}
}

