#!/bin/sh

if [ $# -ne 2 ]; then
	echo "Usage: $0 <version> <build_name>"
	exit 1
fi

VERSION=$1
BUILD_NAME=$2

if [ -d bin/DesertPaintLab.app ]; then
	mkdir -p old
	/bin/mv bin/DesertPaintLab.app old/DesertPaintLab.app.`/bin/date +"%Y%m%d%H%M%S"`
fi
/bin/mkdir -p bin/DesertPaintLab.app
/bin/mkdir -p bin/DesertPaintLab.app/Contents/MacOS
/bin/cp Info.plist bin/DesertPaintLab.app/Contents/Info.plist
/bin/cp launcher.sh bin/DesertPaintLab.app/Contents/MacOS
/bin/chmod 755 bin/DesertPaintLab.app/Contents/MacOS/launcher.sh
/bin/cp ../bin/x64/Release/DesertPaintLab.exe bin/DesertPaintLab.app/Contents/MacOS/
/bin/mkdir -p bin/DesertPaintLab.app/Contents/Resources
/bin/cp -r ../data bin/DesertPaintLab.app/Contents/Resources/data

/usr/bin/defaults write `pwd`/bin/DesertPaintLab.app/Contents/Info.plist CFBundleShortVersionString ${VERSION}
/usr/bin/defaults write `pwd`/bin/DesertPaintLab.app/Contents/Info.plist CFBundleVersion ${VERSION}

# package up into a DMG
/usr/bin/hdiutil create -volname DesertPaintLab -srcfolder bin/ -ov -format UDIF -fs HFS+ ../publish/DesertPaintLab_${BUILD_NAME}.dmg
